import { GetServerSideProps } from 'next';
import { NextHandler } from 'next-connect';
import { MaybePromise } from 'next-runtime';
import { ParsedUrlQuery } from 'next-runtime/types/querystring';
import Context from './context';
import { Runtime } from './runtime';
export type { Request, Response } from './context';
export interface Registry {
}
export declare type Primatives = string | number | boolean | Date;
export declare type HandlerResponse = Primatives | Record<string, Primatives> | Primatives[] | Record<string, Primatives>[] | undefined;
export declare type Handler<Params extends {} = {}, Body extends {} = {}, Cookies extends {} = {}> = (context: Context<Params, Body, Cookies, keyof Registry> & Registry, next: NextHandler) => MaybePromise<void> | MaybePromise<HandlerResponse>;
export declare type Middleware<Params extends {} = {}, Body extends {} = {}, Cookies extends {} = {}> = (context: Context<Params, Body, Cookies, keyof Registry> & Registry, next: NextHandler) => MaybePromise<void>;
interface Params extends Record<string, any> {
}
interface Body extends Record<string, any> {
}
interface Cookies extends Record<string, any> {
}
interface API {
    <Props extends Record<string, any>, Query extends ParsedUrlQuery = ParsedUrlQuery, Body extends Record<string, unknown> = Record<string, unknown>>(runtime: Runtime<Props, Query, Body>): GetServerSideProps<Props, Query>;
    all<P = Params, B = Body, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    get<P = Params, B = Body, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    head<P = Params, B = Body, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    post<B = Body, P = Params, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    put<B = Body, P = Params, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    delete<P = Params, B = Body, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    options<P = Params, B = Body, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    trace<P = Params, B = Body, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    patch<B = Body, P = Params, C = Cookies>(...handlers: Handler<P, B, C>[]): this;
    use<P = Params, B = Body, C = Cookies>(...middleware: Middleware<P, B, C>[]): this;
}
export declare const handler: API;
export default handler;
