import { NextApiRequest, NextApiResponse } from 'next';
export interface Request<Params = any, Body = any, Cookies = any> extends NextApiRequest {
    query: Params;
    cookies: Cookies;
    body: Body;
}
export interface Response extends NextApiResponse {
}
export default class Context<Params, Body, Cookies, Registry> {
    req?: Request<Params, Body, Cookies>;
    res?: Response;
    set(path: Registry, value: any): this;
    get(path: Registry, defaultValue?: string): string | Exclude<this[any], undefined>;
    has(path: Registry): boolean;
    attach(obj: Record<string, any>): this;
}
