"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
class Context {
    set(path, value) {
        return (0, lodash_1.set)(this, path, value);
    }
    get(path, defaultValue) {
        return (0, lodash_1.get)(this, path, defaultValue);
    }
    has(path) {
        return (0, lodash_1.has)(this, path);
    }
    attach(obj) {
        for (const [key, value] of Object.entries(obj)) {
            this.set(key, value);
        }
        return this;
    }
}
exports.default = Context;
//# sourceMappingURL=context.js.map