"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = exports.off = exports.on = void 0;
const events = global.__NEXT_SAAS_EVENTS__ || [];
const on = (type, handler) => {
    (events[type] || (events[type] = [])).push(handler);
    return () => (0, exports.off)(type, handler);
};
exports.on = on;
const off = (type, handler) => {
    if (events[type]) {
        events[type].splice(events[type].indexOf(handler) >>> 0, 1);
    }
};
exports.off = off;
const emit = (type, event) => __awaiter(void 0, void 0, void 0, function* () {
    return Promise.all((events[type] || []).slice().map((handler) => handler(event)));
});
exports.emit = emit;
//# sourceMappingURL=event.js.map